## tulip 4.7.0dfsg

=== CMakeLists.txt ===
IF(WIN32)
CMAKE_MINIMUM_REQUIRED(VERSION 2.8.11)
ELSE(WIN32)
CMAKE_MINIMUM_REQUIRED(VERSION 2.8.3)
ENDIF(WIN32)

# Remove CMake warnings related to Qt5
IF(POLICY CMP0020)
   CMAKE_POLICY(SET CMP0020 NEW)
ENDIF(POLICY CMP0020)

PROJECT(tulip)

SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR})

## ========================================================
## Build type detection
## ========================================================

IF(CMAKE_BUILD_TYPE MATCHES "[Dd][Ee][Bb][Uu][Gg]")
   SET(CMAKE_DEBUG_MODE TRUE)
ELSE(CMAKE_BUILD_TYPE MATCHES "[Dd][Ee][Bb][Uu][Gg]")
   SET(CMAKE_DEBUG_MODE FALSE)
ENDIF(CMAKE_BUILD_TYPE MATCHES "[Dd][Ee][Bb][Uu][Gg]")

## ========================================================
## Check processor architecture
## ========================================================
STRING(COMPARE EQUAL "${CMAKE_SIZEOF_VOID_P}" "8" I64)
IF(I64)
  SET(PROCESSOR_ARCHITECTURE "64")
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DI64")
ELSE(I64)
  SET(PROCESSOR_ARCHITECTURE "32")
ENDIF(I64)

## ========================================================
## Consider FreeBSD as Linux
## ========================================================
EXEC_PROGRAM(uname OUTPUT_VARIABLE UNAME_OUT)
STRING(COMPARE EQUAL "${UNAME_OUT}" "Linux" LINUX)
IF(NOT LINUX)
  STRING(COMPARE EQUAL "${UNAME_OUT}" "GNU/kFreeBSD" LINUX)
ENDIF(NOT LINUX)

## ========================================================
## Operating system preprocessor macros
## ========================================================
IF(LINUX)
  ADD_DEFINITIONS("-D_LINUX")
ENDIF(LINUX)
IF(WIN32)
  ADD_DEFINITIONS("-D_WIN32")
ENDIF(WIN32)
IF(APPLE)
  ADD_DEFINITIONS("-D__APPLE__")
ENDIF(APPLE)

## ========================================================
## Tulip version variables
## ========================================================
SET(TulipMajorVersion 4)
SET(TulipMinorVersion 7)
SET(TulipReleaseVersion 0)
SET(TulipVersionSeparator .)
IF(MSVC) #specific options for Visual Studio
  SET(TulipVersionSeparator _)
ENDIF()
SET(TulipVersion "${TulipMajorVersion}${TulipVersionSeparator}${TulipMinorVersion}${TulipVersionSeparator}${TulipReleaseVersion}")
SET(TulipMMVersion "${TulipMajorVersion}${TulipVersionSeparator}${TulipMinorVersion}")
SET(TulipIntVersion "${TulipMajorVersion}${TulipMinorVersion}${TulipReleaseVersion}")

## ========================================================
## Tulip libraries names
## ========================================================
SET(LibTulipCoreName "tulip-core-${TulipMMVersion}")
SET(LibTulipOglName "tulip-ogl-${TulipMMVersion}")
SET(LibTulipGUIName "tulip-gui-${TulipMMVersion}")
SET(LibTulipPythonName "tulip-python-${TulipMMVersion}")
SET(LibTulipOGDFName "tulip-ogdf-${TulipMMVersion}")
SET(LibStlPythonBindingsName "stl-python-bindings")
SET(LibTulipCorePythonBindingsName "tulip-core-python-bindings")
SET(LibTulipOGLPythonBindingsName "tulip-opengl-python-bindings")
SET(LibTulipGUIPythonBindingsName "tulip-gui-python-bindings")
SET(TulipLibs ${LibTulipCoreName} ${LibTulipOglName} ${LibTulipGUIName} ${LibTulipOGDFName})

## ========================================================
## Current year (used in documentation config files)
## ========================================================
IF (WIN32)
  EXECUTE_PROCESS(COMMAND "cmd.exe" "/c" "echo" "%DATE:~6,4%" OUTPUT_VARIABLE CurrentYear OUTPUT_STRIP_TRAILING_WHITESPACE)
ELSEIF(UNIX)
  EXECUTE_PROCESS(COMMAND "date" "+%Y" OUTPUT_VARIABLE CurrentYear OUTPUT_STRIP_TRAILING_WHITESPACE)
ENDIF()

## ========================================================
## Configure file for uninstall target
## ========================================================
CONFIGURE_FILE("${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in" "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake" IMMEDIATE @ONLY)
ADD_CUSTOM_TARGET(uninstall COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake VERBATIM)

## ========================================================
## Additional macros
## ========================================================
INCLUDE(TulipUseFile.cmake)

## ========================================================
## Profiling
## ========================================================
SET(BUILD_CODE_COVERAGE OFF CACHE BOOL "Do you want to build for code coverage ? [OFF|ON]")

## ========================================================
## Compiler-specific options
## ========================================================
STRING(COMPARE EQUAL "${CMAKE_CXX_COMPILER_ID}" "Clang" CLANG)

SET_COMPILER_OPTIONS()

IF(BUILD_CODE_COVERAGE)
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fprofile-arcs -ftest-coverage")
  SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fprofile-arcs -ftest-coverage")
  SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -fprofile-arcs -ftest-coverage")
  SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -fprofile-arcs -ftest-coverage")
ENDIF()

## ========================================================
## CORE ONLY
## this used to have a minimal build of Tulip without
## any of the opengl, qt or python components
## ========================================================
IF(NOT EXISTS ${PROJECT_SOURCE_DIR}/FindQtX.cmake OR EMSCRIPTEN)
  SET(BUILD_CORE_ONLY ON)
  MESSAGE("You can only configure a core build of Tulip.")
ELSE()
SET(BUILD_CORE_ONLY OFF CACHE BOOL "Do you want a minimal build of Tulip ? [ON|OFF]")
ENDIF()

IF(BUILD_CORE_ONLY AND LINUX)
# the macro ADD_CORE_FILES will be used
# to collect the files needed to build a minimal Tulip
# in the directory pointed by CMAKE_CURRENT_SOURCE_DIR
  macro(ADD_CORE_FILES files)
    set(CURRENT_SOURCE_DIR ".")
    if(${CMAKE_CURRENT_SOURCE_DIR} STRGREATER ${PROJECT_SOURCE_DIR})
      execute_process(COMMAND echo -n ${CMAKE_CURRENT_SOURCE_DIR}
	COMMAND sed "s,${PROJECT_SOURCE_DIR}/,,"
	OUTPUT_VARIABLE CURRENT_SOURCE_DIR)
    endif()
    if(${files} STREQUAL ".")
      SET(ENV{CORE_FILES} "$ENV{CORE_FILES} \$(find ${CURRENT_SOURCE_DIR} -path \"*/.svn\" -prune -o -type f -print)")
    else()
      foreach(core_file ${ARGV})
	SET(ENV{CORE_FILES} "$ENV{CORE_FILES} ${CURRENT_SOURCE_DIR}/${core_file}")
      endforeach()
    endif()
  endmacro()
  ADD_CORE_FILES(CMakeLists.txt cmake_uninstall.cmake.in TulipUseFile.cmake)
# the macro ADD_CORE_DIRECTORY_EXCEPT will be used
# to exclude the files not needed to build a minimal Tulip
# in the directory pointed by CMAKE_CURRENT_SOURCE_DIR
  macro(ADD_CORE_DIRECTORY_EXCEPT files)
    set(CURRENT_SOURCE_DIR ".")
    if(${CMAKE_CURRENT_SOURCE_DIR} STRGREATER ${PROJECT_SOURCE_DIR})
      execute_process(COMMAND echo -n ${CMAKE_CURRENT_SOURCE_DIR}
	COMMAND sed "s,${PROJECT_SOURCE_DIR}/,,"
	OUTPUT_VARIABLE CURRENT_SOURCE_DIR)
    endif()
    SET(find_command "\$(find ${CURRENT_SOURCE_DIR} -path \"*/.svn\" -prune -o -type f")
    foreach(exclude_file ${ARGV})
      SET(find_command "${find_command} -a ! -name \"${exclude_file}\"")
    endforeach()
    SET(ENV{CORE_FILES} "$ENV{CORE_FILES} ${find_command} -print)")
  endmacro()
ELSE()
  macro(ADD_CORE_FILES files)
  endmacro()
  macro(ADD_CORE_DIRECTORY_EXCEPT files)
  endmacro()
ENDIF()

SET(BUILD_PYTHON_COMPONENTS ON CACHE BOOL "Do you want to build Tulip Python components ? [ON|OFF]")

## ========================================================
## Required packages
## ========================================================
IF(MINGW)
# Set some common libraries and headers search paths for MinGW
SET(CMAKE_LIBRARY_PATH "${MINGW_BIN_PATH};${MINGW_LIB_PATH};${MINGW_LIB64_PATH};${CMAKE_LIBRARY_PATH}")
SET(CMAKE_INCLUDE_PATH "${MINGW_INCLUDE_PATH};${MINGW_INCLUDE_PATH}/freetype2;${MINGW_INCLUDE_PATH}/libpng*;${CMAKE_INCLUDE_PATH}")

# Check if libintl is present in the MinGW build environment
FIND_LIBRARY(LIBINTL_FOUND intl PATHS ${MINGW_LIB_PATH} ${MINGW_LIB64_PATH} NO_DEFAULT_PATH)
ENDIF(MINGW)


# ZLIB
FIND_PACKAGE(ZLIB REQUIRED)

# Yajl
SET(YAJL_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/thirdparty/yajl/src ${CMAKE_CURRENT_SOURCE_DIR}/thirdparty/yajl/src/api ${CMAKE_CURRENT_BINARY_DIR}/thirdparty/yajl/yajl-2.1.0/include)

# OpenMP
IF(NOT CLANG)
FIND_PACKAGE(Threads)
OPTION(ENABLE_OPENMP "Do you want to enable OpenMP?" ON)
IF(ENABLE_OPENMP)
    FIND_PACKAGE(OpenMP)
    IF(OPENMP_FOUND)
        SET(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} ${OpenMP_CXX_FLAGS}")
        SET(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} ${OpenMP_CXX_FLAGS}")
        SET(OPENMP_CXX_FLAGS "${OpenMP_CXX_FLAGS}")
        IF(WIN32)
            IF(MSVC)
                SET(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /openmp")
                SET(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} /openmp")
                SET(OPENMP_CXX_FLAGS "/openmp")
            ELSE()
                SET(CMAKE_CXX_STANDARD_LIBRARIES "${CMAKE_CXX_STANDARD_LIBRARIES} -lgomp ${CMAKE_THREAD_LIBS_INIT}")
                SET(OPENMP_LIBRARIES "-lgomp -lpthread")
            ENDIF()
        ENDIF()
    ELSE(OPENMP_FOUND)
        IF(WIN32)
            STRING(COMPARE NOTEQUAL "${OpenMP_C_FLAGS}" "" OMP_CFLAGS)
            IF(OMP_CFLAGS)
                # Force setting OpenMP flags on Windows plateforms
                SET(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} ${OpenMP_C_FLAGS}")
                SET(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} ${OpenMP_C_FLAGS}")
                SET(OPENMP_CXX_FLAGS "${OpenMP_C_FLAGS}")
                IF(NOT MSVC)
                    SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${OpenMP_C_FLAGS}")
                    SET(OPENMP_LINKER_FLAGS "${OpenMP_C_FLAGS}")
                    SET(CMAKE_CXX_STANDARD_LIBRARIES "${CMAKE_CXX_STANDARD_LIBRARIES} -lgomp -lpthread")
                    SET(OPENMP_LIBRARIES "-lgomp -lpthread")
                ENDIF(NOT MSVC)
                SET(OPENMP_FOUND TRUE)
            ELSE(OMP_CFLAGS)
                MESSAGE("OpenMP not found: multithreaded code will not be used")
            ENDIF(OMP_CFLAGS)
        ELSE(WIN32)
            MESSAGE("OpenMP not found: multithreaded code will not be used")
        ENDIF(WIN32)
        ## ========================================================
        ## Enable debugging of OpenMP
        ## ========================================================
        IF(CMAKE_DEBUG_MODE AND NOT CHECK_MEMORY)
            SET(DEBUG_OPENMP OFF CACHE BOOL "Do you want to enable OpenMP even in Debug mode ? [OFF|ON]")
            IF(DEBUG_OPENMP)
                SET(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} ${OPENMP_CXX_FLAGS}")
                SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${OPENMP_LINKER_FLAGS}")
                SET(CMAKE_CXX_STANDARD_LIBRARIES "${CMAKE_CXX_STANDARD_LIBRARIES} ${OPENMP_LIBRARIES}")
            ENDIF(DEBUG_OPENMP)
        ENDIF(CMAKE_DEBUG_MODE AND NOT CHECK_MEMORY)
    ENDIF(OPENMP_FOUND)
ENDIF(ENABLE_OPENMP)
ENDIF(NOT CLANG)

IF(NOT BUILD_CORE_ONLY)

# OpenGL
FIND_PACKAGE(OpenGL REQUIRED)

# Glew
FIND_PACKAGE(GLEW REQUIRED)

# Jpeg
FIND_PACKAGE(JPEG REQUIRED)

# Png
FIND_PACKAGE(PNG REQUIRED)

# Freetype
FIND_PACKAGE(Freetype REQUIRED)

# Qt
FIND_PACKAGE(QtX)

# Quazip
FIND_PACKAGE(QuaZip)

IF(BUILD_PYTHON_COMPONENTS)
# Python
# After finding the Python interpreter, try to find if SIP and its dev tools are installed on the host system.
# If not, compile the SIP version located in thirdparty.
FIND_PACKAGE(PythonInterp REQUIRED)
IF(PYTHONINTERP_FOUND)
  EXECUTE_PROCESS(COMMAND ${PYTHON_EXECUTABLE} --version OUTPUT_VARIABLE PYTHON_VERSION_RAW ERROR_VARIABLE PYTHON_VERSION_RAW)
  STRING(REPLACE "\n" "" PYTHON_VERSION_RAW "${PYTHON_VERSION_RAW}")
  STRING(REGEX MATCH "[0-9]\\.[0-9]" PYTHON_VERSION "${PYTHON_VERSION_RAW}")
  STRING(REGEX MATCH "[0-9]\\.[0-9]\\.[0-9]" PYTHON_VERSION_WITH_PATCH "${PYTHON_VERSION_RAW}")

  # Unset the previous values of the CMake cache variables related to Python libraries

=== doc/CMakeLists.txt ===
SET(BUILD_DOC ON CACHE BOOL "Do you want to build the documentation ? [ON|OFF]")

#Only
IF(BUILD_DOC)
  # Unset the previous values of the CMake cache variable SPHINX_EXECUTABLE
  # in case the value of PYTHON_EXECUTABLE CMake variable changed
  UNSET(SPHINX_EXECUTABLE CACHE)
  SET(Sphinx_DIR ${CMAKE_CURRENT_SOURCE_DIR}/python)
  MARK_AS_ADVANCED(Sphinx_DIR)
  FIND_PACKAGE(Sphinx)
  IF(SPHINX_FOUND)
    IF(BUILD_PYTHON_COMPONENTS)
      ADD_SUBDIRECTORY(python)
    ENDIF(BUILD_PYTHON_COMPONENTS)
    ADD_SUBDIRECTORY(user)
    ADD_SUBDIRECTORY(developer)
  ELSE(SPHINX_FOUND)
    MESSAGE(AUTHOR_WARNING "Sphinx not found: unable to generate the documentation.")
  ENDIF(SPHINX_FOUND)

  IF(LINUX OR APPLE)
    FIND_PACKAGE(Doxygen)
    IF(DOXYGEN_FOUND)
      ADD_SUBDIRECTORY(doxygen)
    ELSE(DOXYGEN_FOUND)
      MESSAGE(AUTHOR_WARNING "doxygen not found: unable to generate the documentation.")
    ENDIF(DOXYGEN_FOUND)
  ENDIF(LINUX OR APPLE)
ENDIF(BUILD_DOC)

=== thirdparty/CMakeLists.txt ===
DISABLE_COMPILER_WARNINGS()

ADD_CORE_FILES(CMakeLists.txt)

ADD_SUBDIRECTORY(gzstream)
ADD_SUBDIRECTORY(OGDF)
ADD_SUBDIRECTORY(libqhull)
ADD_SUBDIRECTORY(yajl)

IF(NOT BUILD_CORE_ONLY)
ADD_SUBDIRECTORY(ftgl)
IF(NOT QUAZIP_FOUND)
  ADD_SUBDIRECTORY(quazip)
ENDIF(NOT QUAZIP_FOUND)
ADD_SUBDIRECTORY(qxt)
ADD_SUBDIRECTORY(QtAwesome)

IF(PYTHONLIBS_FOUND AND PYTHONINTERP_FOUND)
  IF(SIP_OK AND NOT SIP_FOUND)
    ADD_SUBDIRECTORY(sip-${SIP_VERSION_THIRDPARTY})
  ENDIF(SIP_OK AND NOT SIP_FOUND)
ENDIF(PYTHONLIBS_FOUND AND PYTHONINTERP_FOUND)
ENDIF(NOT BUILD_CORE_ONLY)

## -----------------------------------------------------------------------------------------------
## Install external libraries.
## Each external library is defined in its own component to ensure easy modifications of the CPack component dependency tree
## -----------------------------------------------------------------------------------------------

IF(WIN32)
## -----------------------------------------------------------------------------------------------
## Windows
## -----------------------------------------------------------------------------------------------

# Note: On Win32 systems, CMake variables doesn't provide the right libraries that have to be included in the bundle. (For instance, Qt variables redirect to .lib and not .dll)
#       We have to manually find those libs by invoking the FIND_LIBRARY_GLOB macro

# Base System
# Libs needed to provide sufficient runtime under Windows environments
  IF(MINGW)

    # base runtime
    INSTALL_EXTERNAL_LIB("libgcc_s_*.dll" runtime)
    INSTALL_EXTERNAL_LIB("libstdc++-*.dll" runtime)

    # install libintl and its dependency libiconv if found in the MinGW build environment
    IF(LIBINTL_FOUND)
      INSTALL_EXTERNAL_LIB("libintl*.dll" intl)
      INSTALL_EXTERNAL_LIB("*iconv.dll" iconv)
    ENDIF(LIBINTL_FOUND)

    # install pthread lib in all cases as it is a frequent dependency
    INSTALL_EXTERNAL_LIB("*pthread*.dll" runtime)

    # OpenMP runtime
    IF(OPENMP_FOUND)
      INSTALL_EXTERNAL_LIB("libgomp-*.dll" runtime)
    ENDIF(OPENMP_FOUND)

    # dependencies for old MinGW compilers
    IF(GCXX_VERSION VERSION_LESS 4.8)
      INSTALL_EXTERNAL_LIB("mingwm*.dll" runtime)
      INSTALL_EXTERNAL_LIB("libiconv-2.dll" iconv)
    ENDIF(GCXX_VERSION VERSION_LESS 4.8)

  ENDIF(MINGW)

  INSTALL_EXTERNAL_LIB_IF_NEEDED(${ZLIB_LIBRARY} zlib)

IF(NOT BUILD_CORE_ONLY)
  INSTALL_EXTERNAL_LIB_IF_NEEDED(${GLEW_LIBRARY} glew)
  INSTALL_EXTERNAL_LIB_IF_NEEDED(${FREETYPE_LIBRARY} freetype)
  INSTALL_EXTERNAL_LIB_IF_NEEDED(${JPEG_LIBRARY} jpeg)
  INSTALL_EXTERNAL_LIB_IF_NEEDED(${PNG_LIBRARY} png)

  IF(USE_QT4)
    INSTALL_EXTERNAL_LIB("QtCore4.dll" qt)
    INSTALL_EXTERNAL_LIB("QtGui4.dll" qt)
    INSTALL_EXTERNAL_LIB("QtNetwork4.dll" qt)
    INSTALL_EXTERNAL_LIB("QtOpenGL4.dll" qt)
    INSTALL_EXTERNAL_LIB("QtXml4.dll" qt)
    INSTALL_EXTERNAL_LIB("QtWebKit4.dll" qt)

    IF(CMAKE_DEBUG_MODE OR MSVC)
      INSTALL_EXTERNAL_LIB("QtCored4.dll" qt)
      INSTALL_EXTERNAL_LIB("QtGuid4.dll" qt)
      INSTALL_EXTERNAL_LIB("QtNetworkd4.dll" qt)
      INSTALL_EXTERNAL_LIB("QtOpenGLd4.dll" qt)
      INSTALL_EXTERNAL_LIB("QtXmld4.dll" qt)
      INSTALL_EXTERNAL_LIB("QtWebKitd4.dll" qt)
    ENDIF(CMAKE_DEBUG_MODE OR MSVC)

    IF(QT_PHONON_LIBRARY)
      INSTALL_EXTERNAL_LIB("phonon4.dll" qt)
      IF(CMAKE_DEBUG_MODE OR MSVC)
        INSTALL_EXTERNAL_LIB("phonond4.dll" qt)
      ENDIF(CMAKE_DEBUG_MODE OR MSVC)
    ENDIF(QT_PHONON_LIBRARY)
  ENDIF(USE_QT4)

  IF(USE_QT5)
    INSTALL_EXTERNAL_LIB("Qt5Core.dll" qt)
    INSTALL_EXTERNAL_LIB("Qt5Gui.dll" qt)
    INSTALL_EXTERNAL_LIB("Qt5Network.dll" qt)
    INSTALL_EXTERNAL_LIB("Qt5OpenGL.dll" qt)
    INSTALL_EXTERNAL_LIB("Qt5Xml.dll" qt)
    INSTALL_EXTERNAL_LIB("Qt5WebKit.dll" qt)
    INSTALL_EXTERNAL_LIB("Qt5WebKitWidgets.dll" qt)
    INSTALL_EXTERNAL_LIB("Qt5Widgets.dll" qt)
    INSTALL_EXTERNAL_LIB("Qt5Multimedia.dll" qt)
    INSTALL_EXTERNAL_LIB("Qt5MultimediaWidgets.dll" qt)
    INSTALL_EXTERNAL_LIB("Qt5PrintSupport.dll" qt)
    INSTALL_EXTERNAL_LIB("Qt5Sensors.dll" qt)
    INSTALL_EXTERNAL_LIB("Qt5Sql.dll" qt)
    INSTALL_EXTERNAL_LIB("Qt5Quick.dll" qt)
    INSTALL_EXTERNAL_LIB("Qt5Qml.dll" qt)

    IF(CMAKE_DEBUG_MODE OR MSVC)
      INSTALL_EXTERNAL_LIB("Qt5Cored.dll" qt)
      INSTALL_EXTERNAL_LIB("Qt5Guid.dll" qt)
      INSTALL_EXTERNAL_LIB("Qt5Networkd.dll" qt)
      INSTALL_EXTERNAL_LIB("Qt5OpenGLd.dll" qt)
      INSTALL_EXTERNAL_LIB("Qt5Xmld.dll" qt)
      INSTALL_EXTERNAL_LIB("Qt5WebKitd.dll" qt)
      INSTALL_EXTERNAL_LIB("Qt5WebKitWidgetsd.dll" qt)
      INSTALL_EXTERNAL_LIB("Qt5Widgetsd.dll" qt)
      INSTALL_EXTERNAL_LIB("Qt5Multimediad.dll" qt)
      INSTALL_EXTERNAL_LIB("Qt5MultimediaWidgetsd.dll" qt)
      INSTALL_EXTERNAL_LIB("Qt5PrintSupportd.dll" qt)
      INSTALL_EXTERNAL_LIB("Qt5Sensorsd.dll" qt)
      INSTALL_EXTERNAL_LIB("Qt5Sqld.dll" qt)
      INSTALL_EXTERNAL_LIB("Qt5Quickd.dll" qt)
      INSTALL_EXTERNAL_LIB("Qt5Qmld.dll" qt)
    ENDIF(CMAKE_DEBUG_MODE OR MSVC)

    INSTALL_EXTERNAL_LIB("icuin*.dll" qt)
    INSTALL_EXTERNAL_LIB("icuuc*.dll" qt)
    INSTALL_EXTERNAL_LIB("icudt*.dll" qt)

    IF(QT_VERSION VERSION_LESS 5.2)
      INSTALL_EXTERNAL_LIB("Qt5V8.dll" qt)
      IF(CMAKE_DEBUG_MODE OR MSVC)
        INSTALL_EXTERNAL_LIB("Qt5V8d.dll" qt)
      ENDIF(CMAKE_DEBUG_MODE OR MSVC)
    ELSE(QT_VERSION VERSION_LESS 5.2)
      INSTALL_EXTERNAL_LIB("Qt5Positioning.dll" qt)
      IF(CMAKE_DEBUG_MODE OR MSVC)
        INSTALL_EXTERNAL_LIB("Qt5Positioningd.dll" qt)
      ENDIF(CMAKE_DEBUG_MODE OR MSVC)
    ENDIF(QT_VERSION VERSION_LESS 5.2)

    IF(QT_VERSION VERSION_GREATER 5.3)
      INSTALL_EXTERNAL_LIB("Qt5WebChannel.dll" qt)
      IF(CMAKE_DEBUG_MODE OR MSVC)
        INSTALL_EXTERNAL_LIB("Qt5WebChanneld.dll" qt)
      ENDIF(CMAKE_DEBUG_MODE OR MSVC)
    ENDIF(QT_VERSION VERSION_GREATER 5.3)


  ENDIF(USE_QT5)
ENDIF(NOT BUILD_CORE_ONLY)

ENDIF(WIN32)

=== library/tulip-python/CMakeLists.txt ===
IF(MINGW AND I64)
  ADD_DEFINITIONS(-DMS_WIN64)
ENDIF(MINGW AND I64)

# VS2013 and beyond implement C99 math functions.  Of interest to Python is the function round().
# Python conditionally provides its own implementation of round() based on whether or not HAVE_ROUND is defined, but in no case is HAVE_ROUND ever defined.
# This leads to a huge spew of warnings when compiling with VS2013, and presumably it also leads to undefined behavior.
# So define HAVE_ROUND for that compiler.
IF(MSVC12)
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DHAVE_ROUND")
ENDIF(MSVC12)

ADD_SUBDIRECTORY(api)
ADD_SUBDIRECTORY(bindings)
ADD_SUBDIRECTORY(include)
ADD_SUBDIRECTORY(modules)
ADD_SUBDIRECTORY(src)

=== plugins/colors/CMakeLists.txt ===
INCLUDE_DIRECTORIES(${TulipCoreInclude} ${TulipCoreBuildInclude} ${TulipOGLInclude} ${TulipGUIInclude} ${CMAKE_CURRENT_BINARY_DIR} .)

##----------------------------------------------------------------------------------------------------------------------------
SET(ColorMapping_SRCS
  ColorMapping.cpp
  DoubleStringsListRelationDialog.cpp
)

QTX_WRAP_UI(ColorMapping_UI_SRCS
  DoubleStringsListRelationDialog.ui
)

QTX_WRAP_CPP(ColorMapping_MOC_SRCS
  DoubleStringsListRelationDialog.h
)

ADD_LIBRARY(ColorMapping-${TulipVersion} SHARED ${ColorMapping_SRCS} ${ColorMapping_UI_SRCS} ${ColorMapping_MOC_SRCS})
TARGET_LINK_LIBRARIES(ColorMapping-${TulipVersion} ${LibTulipCoreName} ${LibTulipOglName} ${LibTulipGUIName})

##----------------------------------------------------------------------------------------------------------------------------
INSTALL_TULIP_PLUGIN(ColorMapping-${TulipVersion} ${TulipPluginsInstallDir})

=== plugins/glyph/CMakeLists.txt ===
INCLUDE_DIRECTORIES(${TulipCoreInclude} ${TulipCoreBuildInclude} ${TulipOGLInclude} ${GLEW_INCLUDE_DIR})

MACRO(GLYPH name source)
  ADD_LIBRARY(${name}-${TulipVersion} SHARED ${source})
  TARGET_LINK_LIBRARIES(${name}-${TulipVersion} ${LibTulipCoreName} ${LibTulipOglName})
  INSTALL_TULIP_PLUGIN(${name}-${TulipVersion} ${TulipGlyphPluginsInstallDir})
ENDMACRO(GLYPH)

GLYPH(Cone cone.cpp)

GLYPH(Circle circle.cpp)
GLYPH(Sphere sphere.cpp)

GLYPH(Square square.cpp)
GLYPH(RoundedBox roundedbox.cpp)
GLYPH(Cube cube.cpp)

GLYPH(Window window.cpp)
GLYPH(Hexagone hexagone.cpp)
GLYPH(Triangle triangle.cpp)
GLYPH(Pentagone pentagone.cpp)
GLYPH(CubeOutlinedTransparent cubeoutlinedtransparent.cpp)
GLYPH(Ring ring.cpp)
GLYPH(Billboard billboard.cpp)
GLYPH(Cylinder cylinder.cpp)
GLYPH(HalfCylinder halfcylinder.cpp)
GLYPH(ChristmasTree christmastree.cpp)
GLYPH(Diamond diamond.cpp)
GLYPH(Cross cross.cpp)
GLYPH(GlowSphere glowsphere.cpp)
GLYPH(Star star.cpp)
GLYPH(FontAwesomeIcon fontawesomeicon.cpp)

## radialGradientTexture.png is used in glowsphere.cpp
INSTALL(FILES
  radialGradientTexture.png
  DESTINATION ${TulipBitmapInstallDir}
  COMPONENT tulip_plugins)

=== plugins/import/CMakeLists.txt ===
ADD_CORE_FILES(CMakeLists.txt *Tree*.cpp *Graph.cpp AdjacencyMatrixImport.cpp dotImport*.* EmptyGraph.cpp GML*.* Grid.cpp GEXFImport.cpp Import*.cpp)

INCLUDE_DIRECTORIES(./ ${TulipCoreInclude} ${TulipCoreBuildInclude} ${TulipGUIInclude} ${UTF8CppInclude})

##----------------------------------------------------------------------------------------------------------------------------
SET(PlanarGraph_SRCS PlanarGraph.cpp)
ADD_LIBRARY(PlanarGraph-${TulipVersion} SHARED ${PlanarGraph_SRCS})
TARGET_LINK_LIBRARIES(PlanarGraph-${TulipVersion} ${LibTulipCoreName})

##------------0----------------------------------------------------------------------------------------------------------------
SET(DotImport_SRCS dotImport.cpp)
ADD_LIBRARY(DotImport-${TulipVersion} SHARED ${DotImport_SRCS})
TARGET_LINK_LIBRARIES(DotImport-${TulipVersion} ${LibTulipCoreName})

##----------------------------------------------------------------------------------------------------------------------------
SET(Grid_SRCS Grid.cpp)
ADD_LIBRARY(Grid-${TulipVersion} SHARED ${Grid_SRCS})
TARGET_LINK_LIBRARIES(Grid-${TulipVersion} ${LibTulipCoreName})

##----------------------------------------------------------------------------------------------------------------------------
SET(GMLImport_SRCS GMLImport.cpp)
ADD_LIBRARY(GMLImport-${TulipVersion} SHARED ${GMLImport_SRCS})
TARGET_LINK_LIBRARIES(GMLImport-${TulipVersion} ${LibTulipCoreName})

##----------------------------------------------------------------------------------------------------------------------------
SET(RandomGraph_SRCS RandomGraph.cpp)
ADD_LIBRARY(RandomGraph-${TulipVersion} SHARED ${RandomGraph_SRCS})
TARGET_LINK_LIBRARIES(RandomGraph-${TulipVersion} ${LibTulipCoreName})

##----------------------------------------------------------------------------------------------------------------------------
SET(RandomSimpleGraph_SRCS RandomSimpleGraph.cpp)
ADD_LIBRARY(RandomSimpleGraph-${TulipVersion} SHARED ${RandomSimpleGraph_SRCS})
TARGET_LINK_LIBRARIES(RandomSimpleGraph-${TulipVersion} ${LibTulipCoreName})

##----------------------------------------------------------------------------------------------------------------------------
SET(AdjacencyMatrixImport_SRCS AdjacencyMatrixImport.cpp)
ADD_LIBRARY(AdjacencyMatrixImport-${TulipVersion} SHARED ${AdjacencyMatrixImport_SRCS})
TARGET_LINK_LIBRARIES(AdjacencyMatrixImport-${TulipVersion} ${LibTulipCoreName})

##----------------------------------------------------------------------------------------------------------------------------
SET(CompleteGraph_SRCS CompleteGraph.cpp)
ADD_LIBRARY(CompleteGraph-${TulipVersion} SHARED ${CompleteGraph_SRCS})
TARGET_LINK_LIBRARIES(CompleteGraph-${TulipVersion} ${LibTulipCoreName})

##----------------------------------------------------------------------------------------------------------------------------
SET(RandomTree_SRCS RandomTree.cpp)
ADD_LIBRARY(RandomTree-${TulipVersion} SHARED ${RandomTree_SRCS})
TARGET_LINK_LIBRARIES(RandomTree-${TulipVersion} ${LibTulipCoreName})

##----------------------------------------------------------------------------------------------------------------------------
SET(RandomTreeGeneral_SRCS RandomTreeGeneral.cpp)
ADD_LIBRARY(RandomTreeGeneral-${TulipVersion} SHARED ${RandomTreeGeneral_SRCS})
TARGET_LINK_LIBRARIES(RandomTreeGeneral-${TulipVersion} ${LibTulipCoreName})

##----------------------------------------------------------------------------------------------------------------------------
SET(CompleteTree_SRCS CompleteTree.cpp)
ADD_LIBRARY(CompleteTree-${TulipVersion} SHARED ${CompleteTree_SRCS})
TARGET_LINK_LIBRARIES(CompleteTree-${TulipVersion} ${LibTulipCoreName})

##----------------------------------------------------------------------------------------------------------------------------
SET(SmallWorldGraph_SRCS SmallWorldGraph.cpp)
ADD_LIBRARY(SmallWorldGraph-${TulipVersion} SHARED ${SmallWorldGraph_SRCS})
TARGET_LINK_LIBRARIES(SmallWorldGraph-${TulipVersion} ${LibTulipCoreName})

##----------------------------------------------------------------------------------------------------------------------------
SET(ImportPajek_SRCS ImportPajek.cpp)
ADD_LIBRARY(ImportPajek-${TulipVersion} SHARED ${ImportPajek_SRCS})
TARGET_LINK_LIBRARIES(ImportPajek-${TulipVersion} ${LibTulipCoreName})

##----------------------------------------------------------------------------------------------------------------------------
SET(ImportUCINET_SRCS ImportUCINET.cpp)
ADD_LIBRARY(ImportUCINET-${TulipVersion} SHARED ${ImportUCINET_SRCS})
TARGET_LINK_LIBRARIES(ImportUCINET-${TulipVersion} ${LibTulipCoreName})

##----------------------------------------------------------------------------------------------------------------------------
ADD_LIBRARY(EmptyGraph-${TulipVersion} SHARED EmptyGraph.cpp)
TARGET_LINK_LIBRARIES(EmptyGraph-${TulipVersion} ${LibTulipCoreName})

##----------------------------------------------------------------------------------------------------------------------------
IF(NOT BUILD_CORE_ONLY)
SET(FileSystem_SRCS FileSystem.cpp)
ADD_LIBRARY(FileSystem-${TulipVersion} SHARED ${FileSystem_SRCS})
TARGET_LINK_LIBRARIES(FileSystem-${TulipVersion} ${LibTulipCoreName} ${QT_LIBRARIES})

##----------------------------------------------------------------------------------------------------------------------------
SET(WebImport_SRCS WebImport.cpp)
QTX_WRAP_CPP(WebImport_MOC_SRCS WebImport.h)
ADD_LIBRARY(WebImport-${TulipVersion} SHARED ${WebImport_SRCS} ${WebImport_MOC_SRCS})
TARGET_LINK_LIBRARIES(WebImport-${TulipVersion} ${LibTulipCoreName} ${LibTulipGUIName} ${QT_LIBRARIES})
##----------------------------------------------------------------------------------------------------------------------------
ADD_LIBRARY(GEXFImport-${TulipVersion} SHARED GEXFImport.cpp)
TARGET_LINK_LIBRARIES(GEXFImport-${TulipVersion} ${LibTulipCoreName} ${QT_LIBRARIES})

##----------------------------------------------------------------------------------------------------------------------------
ADD_SUBDIRECTORY(facebook)
ENDIF(NOT BUILD_CORE_ONLY)
##----------------------------------------------------------------------------------------------------------------------------
INSTALL_TULIP_PLUGIN(PlanarGraph-${TulipVersion} ${TulipPluginsInstallDir})
INSTALL_TULIP_PLUGIN(DotImport-${TulipVersion} ${TulipPluginsInstallDir})
INSTALL_TULIP_PLUGIN(Grid-${TulipVersion} ${TulipPluginsInstallDir})
INSTALL_TULIP_PLUGIN(GMLImport-${TulipVersion} ${TulipPluginsInstallDir})
INSTALL_TULIP_PLUGIN(RandomGraph-${TulipVersion} ${TulipPluginsInstallDir})
INSTALL_TULIP_PLUGIN(RandomSimpleGraph-${TulipVersion} ${TulipPluginsInstallDir})
INSTALL_TULIP_PLUGIN(AdjacencyMatrixImport-${TulipVersion} ${TulipPluginsInstallDir})
INSTALL_TULIP_PLUGIN(CompleteGraph-${TulipVersion} ${TulipPluginsInstallDir})
INSTALL_TULIP_PLUGIN(RandomTree-${TulipVersion} ${TulipPluginsInstallDir})
INSTALL_TULIP_PLUGIN(RandomTreeGeneral-${TulipVersion} ${TulipPluginsInstallDir})
INSTALL_TULIP_PLUGIN(CompleteTree-${TulipVersion} ${TulipPluginsInstallDir})
INSTALL_TULIP_PLUGIN(SmallWorldGraph-${TulipVersion} ${TulipPluginsInstallDir})
IF(NOT BUILD_CORE_ONLY)
INSTALL_TULIP_PLUGIN(FileSystem-${TulipVersion} ${TulipPluginsInstallDir})
INSTALL_TULIP_PLUGIN(WebImport-${TulipVersion} ${TulipPluginsInstallDir})
INSTALL_TULIP_PLUGIN(GEXFImport-${TulipVersion} ${TulipPluginsInstallDir})
ENDIF(NOT BUILD_CORE_ONLY)
INSTALL_TULIP_PLUGIN(ImportPajek-${TulipVersion} ${TulipPluginsInstallDir})
INSTALL_TULIP_PLUGIN(ImportUCINET-${TulipVersion} ${TulipPluginsInstallDir})
INSTALL_TULIP_PLUGIN(EmptyGraph-${TulipVersion} ${TulipPluginsInstallDir})

=== plugins/view/CMakeLists.txt ===
#Commented until SIP bindings are updated to fit with latest Tulip API changes
IF(BUILD_PYTHON_COMPONENTS)
ADD_SUBDIRECTORY(PythonScriptView)
ENDIF(BUILD_PYTHON_COMPONENTS)
ADD_SUBDIRECTORY(HistogramView)
ADD_SUBDIRECTORY(GeographicView)
ADD_SUBDIRECTORY(MatrixView)
ADD_SUBDIRECTORY(ParallelCoordinatesView)
ADD_SUBDIRECTORY(PixelOrientedView)
ADD_SUBDIRECTORY(ScatterPlot2DView)
ADD_SUBDIRECTORY(SOMView)
ADD_SUBDIRECTORY(TableView)

=== software/tulip/CMakeLists.txt ===
SET(SRCS
  src/AboutTulipPage.cpp
  src/main.cpp
  src/PerspectiveItemWidget.cpp
  src/PluginErrorReport.cpp
  src/PluginLoaderDispatcher.cpp
  src/PluginLoaderReporter.cpp
  src/PluginsCenter.cpp
  src/PluginInformationsListItem.cpp
  src/RssParser.cpp
  src/TulipMainWindow.cpp
  src/TulipSplashScreen.cpp
  src/TulipWelcomePage.cpp
  src/TulipPerspectiveProcessHandler.cpp
  src/TulipPerspectiveCrashHandler.cpp
  src/FormPost.cpp
  src/PerspectiveSelectionDialog.cpp
)

QTX_WRAP_UI(UI_HEADERS
  designer/AboutTulipPage.ui
  designer/PerspectiveItem.ui
  designer/PluginErrorReport.ui
  designer/PluginsCenter.ui
  designer/TulipMainWindow.ui
  designer/TulipWelcomePage.ui
  designer/PluginInformationsListItem.ui
  designer/TulipPerspectiveCrashHandler.ui
  designer/PerspectiveSelectionDialog.ui
)

QTX_WRAP_CPP(MOC_SRCS
  include/PerspectiveItemWidget.h
  include/PluginErrorReport.h
  include/PluginsCenter.h
  include/TulipMainWindow.h
  include/TulipWelcomePage.h
  include/PluginInformationsListItem.h
  include/TulipPerspectiveProcessHandler.h
  include/TulipPerspectiveCrashHandler.h
  include/FormPost.h
  include/PerspectiveSelectionDialog.h
)

QTX_ADD_RESOURCES(RCC_SRCS resources/TulipAgent.qrc)

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/../crash_handling)

INCLUDE_DIRECTORIES(include ${CMAKE_CURRENT_BINARY_DIR} ${TulipCoreBuildInclude} ${TulipCoreInclude} ${TulipOGLInclude} ${TulipGUIInclude} ${QxtInclude})

IF(USE_QT5)
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5Widgets_EXECUTABLE_COMPILE_FLAGS}")
ENDIF(USE_QT5)

IF(BUILD_PYTHON_COMPONENTS)
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DBUILD_PYTHON_COMPONENTS")
ENDIF(BUILD_PYTHON_COMPONENTS)

IF(WIN32)

STRING(TIMESTAMP CURRENT_YEAR "%Y")

INCLUDE(generate_product_version)
generate_product_version(
   VersionFiles
   NAME "Tulip Agent"
   ICON ${PROJECT_SOURCE_DIR}/library/tulip-gui/resources/icons/tulip.ico
   VERSION_MAJOR ${TulipMajorVersion}
   VERSION_MINOR ${TulipMinorVersion}
   VERSION_PATCH ${TulipReleaseVersion}
   COMPANY_NAME "LaBRI, University of Bordeaux"
   COMPANY_COPYRIGHT "(C) Copyright ${CURRENT_YEAR} David Auber and the Tulip development Team"
   ORIGINAL_FILENAME "tulip.exe"
)

SET(SRCS ${SRCS} ${VersionFiles})

ENDIF(WIN32)

ADD_EXECUTABLE(tulip ${SRCS} ${UI_HEADERS} ${MOC_SRCS} ${RCC_SRCS})

IF(LINUX OR APPLE)
  SET_TARGET_PROPERTIES(tulip PROPERTIES INSTALL_RPATH "$ORIGIN/../lib")
ELSE()
  SET_TARGET_PROPERTIES(tulip PROPERTIES INSTALL_RPATH "$ORIGIN")
ENDIF()

TARGET_LINK_LIBRARIES(tulip crash_handling ${LibTulipCoreName} ${LibTulipOGLName} ${LibTulipGUIName} ${QT_LIBRARIES} ${QxtLibrary})

INSTALL(TARGETS tulip
  RUNTIME DESTINATION ${TulipBinInstallDir} COMPONENT tulip_app
  LIBRARY DESTINATION ${TulipLibInstallDir} COMPONENT tulip_app
  ARCHIVE DESTINATION ${TulipLibInstallDir} COMPONENT tulip_app)

=== software/tulip_perspective/CMakeLists.txt ===
SET(SRCS
  src/main.cpp
  src/TulipPerspectiveMainWindow.cpp
)

QTX_WRAP_CPP(MOC_SRCS
  include/TulipPerspectiveMainWindow.h
)

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/../crash_handling)

INCLUDE_DIRECTORIES(${TulipCoreInclude} ${TulipCoreBuildInclude} ${TulipOGLInclude} ${TulipGUIInclude} include/)

IF(USE_QT5)
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5Widgets_EXECUTABLE_COMPILE_FLAGS}")
ENDIF(USE_QT5)

IF(WIN32)

STRING(TIMESTAMP CURRENT_YEAR "%Y")

INCLUDE(generate_product_version)
generate_product_version(
   VersionFiles
   NAME "Tulip Perspective launcher"
   ICON ${PROJECT_SOURCE_DIR}/library/tulip-gui/resources/icons/tulip.ico
   VERSION_MAJOR ${TulipMajorVersion}
   VERSION_MINOR ${TulipMinorVersion}
   VERSION_PATCH ${TulipReleaseVersion}
   COMPANY_NAME "LaBRI, University of Bordeaux"
   COMPANY_COPYRIGHT "(C) Copyright ${CURRENT_YEAR} David Auber and the Tulip development Team"
   ORIGINAL_FILENAME "tulip_perspective.exe"
)

SET(SRCS ${SRCS} ${VersionFiles})

ENDIF(WIN32)

ADD_EXECUTABLE(tulip_perspective ${SRCS} ${MOC_SRCS})

IF(LINUX)
  SET_TARGET_PROPERTIES(tulip_perspective PROPERTIES INSTALL_RPATH "$ORIGIN/../lib")
ELSEIF(APPLE)
  SET_TARGET_PROPERTIES(tulip_perspective PROPERTIES INSTALL_RPATH "$ORIGIN/../lib")
ELSE()
  SET_TARGET_PROPERTIES(tulip_perspective PROPERTIES INSTALL_RPATH "$ORIGIN")
ENDIF()

TARGET_LINK_LIBRARIES(tulip_perspective crash_handling)

TARGET_LINK_LIBRARIES(tulip_perspective ${LibTulipCoreName} ${LibTulipOGLName} ${LibTulipGUIName} ${QT_LIBRARIES})

INSTALL(TARGETS tulip_perspective
  RUNTIME DESTINATION ${TulipBinInstallDir} COMPONENT tulip_app
  LIBRARY DESTINATION ${TulipLibInstallDir} COMPONENT tulip_app
  ARCHIVE DESTINATION ${TulipLibInstallDir} COMPONENT tulip_app)

=== library/tulip-core/src/CMakeLists.txt ===
SET(tulip_LIB_SRCS ${tulip_LIB_SRCS}
Plugin.cpp
AcyclicTest.cpp
Bfs.cpp
BiconnectedTest.cpp
BooleanProperty.cpp
BoundingBox.cpp
Color.cpp
ColorProperty.cpp
ColorScale.cpp
ConnectedTest.cpp
ConvexHull.cpp
DataSet.cpp
Delaunay.cpp
DoubleProperty.cpp
DrawingTools.cpp
FaceIterator.cpp
GraphAbstract.cpp
Graph.cpp
GraphDecorator.cpp
GraphImpl.cpp
GraphIterator.cpp
GraphMeasure.cpp
GraphProperty.cpp
GraphStorage.cpp
GraphTools.cpp
GraphUpdatesRecorder.cpp
GraphView.cpp
IdManager.cpp
IntegerProperty.cpp
LayoutProperty.cpp
MapIterator.cpp
Observable.cpp
Ordering.cpp
OuterPlanarTest.cpp
ParametricCurves.cpp
PlanarConMap.cpp
PlanarityTest.cpp
PlanarityTestEmbed.cpp
PlanarityTestImpl.cpp
PlanarityTestObstr.cpp
PlanarityTestTools.cpp
Plane.cpp
PluginLibraryLoader.cpp
PluginLoaderTxt.cpp
PropertyAlgorithm.cpp
PropertyInterface.cpp
PropertyManager.cpp
PropertyTypes.cpp
SimplePluginProgress.cpp
SimpleTest.cpp
SizeProperty.cpp
StlFunctions.cpp
StringCollection.cpp
StringProperty.cpp
TLPExport.cpp
TLPImport.cpp
TlpTools.cpp
TreeTest.cpp
TriconnectedTest.cpp
vectorgraph.cpp
WithParameter.cpp
YajlFacade.cpp
PluginLister.cpp
tulipconf.cpp
TulipException.cpp
PluginProgress.cpp
TulipViewSettings.cpp
TlpJsonExport.cpp
TlpJsonImport.cpp
TLPBExport.cpp
TLPBImport.cpp
TulipFontAwesome.cpp
)

# disable GCC var tracking on that file as it eats too much compile time
IF(CMAKE_COMPILER_IS_GNUCXX)
SET_SOURCE_FILES_PROPERTIES(TulipFontAwesome.cpp COMPILE_FLAGS -fno-var-tracking)
ENDIF(CMAKE_COMPILER_IS_GNUCXX)

IF(CHECK_MEMORY)
SET(tulip_LIB_SRCS ${tulip_LIB_SRCS} MemoryChecker.cpp)
ENDIF(CHECK_MEMORY)

IF(EMSCRIPTEN)
SET(tulip_LIB_SRCS ${tulip_LIB_SRCS}
                    ../../../plugins/layout/DatasetTools.cpp
                    ../../../plugins/layout/OrientableCoord.cpp
                    ../../../plugins/layout/OrientableLayout.cpp
                    ../../../plugins/layout/OrientableSize.cpp
                    ../../../plugins/layout/OrientableSizeProxy.cpp
                    ../../../plugins/layout/Orientation.cpp)
ENDIF(EMSCRIPTEN)

SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D_TULIP_LIB_DIR=\"\\\"${CMAKE_INSTALL_PREFIX}/lib/\\\"\"")
INCLUDE_DIRECTORIES(../include/ ${TulipCoreBuildInclude} ${PROJECT_SOURCE_DIR} ${ZLIB_INCLUDE_DIR} ${YAJL_INCLUDE_DIRS} ${QHULLInclude} ${GZStreamInclude} ${UTF8CppInclude})

ADD_LIBRARY(${LibTulipCoreName} SHARED ${tulip_LIB_SRCS} ../include/tulip/TulipRelease.h)
TARGET_LINK_LIBRARIES(${LibTulipCoreName} ${GZStreamLibrary} ${YajlLibrary} qhull ${CMAKE_DL_LIBS})
IF(WIN32)
  IF(MSVC)
    TARGET_LINK_LIBRARIES(${LibTulipCoreName} Dbghelp)
    IF(${CMAKE_GENERATOR} MATCHES "Visual Studio 9" OR ${CMAKE_GENERATOR} MATCHES "NMake Makefiles")
      SET_TARGET_PROPERTIES(${LibTulipCoreName} PROPERTIES LINK_FLAGS " /NODEFAULTLIB:LIBCMT.lib ")
    ENDIF()
  ENDIF()
ENDIF(WIN32)

INSTALL(TARGETS ${LibTulipCoreName}
  RUNTIME DESTINATION ${TulipBinInstallDir} COMPONENT tulip_core
  LIBRARY DESTINATION ${TulipLibInstallDir} COMPONENT tulip_core
  ARCHIVE DESTINATION ${TulipLibInstallDir} COMPONENT tulip_core)

=== library/tulip-gui/src/CMakeLists.txt ===

SET(SRCS
  ColorScaleConfigDialog.cpp
  ColorScaleWidget.cpp
  CopyPropertyDialog.cpp
  CSVGraphImport.cpp
  CSVGraphMappingConfigurationWidget.cpp
  CSVImportConfigurationWidget.cpp
  CSVImportWizard.cpp
  CSVParserConfigurationWidget.cpp
  CSVParser.cpp
  DocumentationNavigator.cpp
  DoubleStringsListSelectionWidget.cpp
  DownloadManager.cpp
  DragHandle.cpp
  GlCompositeHierarchyManager.cpp
  GlMainView.cpp
  GlMainWidget.cpp
  GlOffscreenRenderer.cpp
  GraphPropertiesSelectionWidget.cpp
  ItemsListWidget.cpp
  MouseBoxZoomer.cpp
  MouseEdgeBendEditor.cpp
  MouseEdgeBuilder.cpp
  MouseEdgeSelector.cpp
  MouseInteractors.cpp
  MouseNodeBuilder.cpp
  MouseSelectionEditor.cpp
  MouseSelector.cpp
  MouseShowElementInfos.cpp
  NodeLinkDiagramComponent.cpp
  NodeLinkDiagramComponentInteractor.cpp
  Perspective.cpp
  PluginManager.cpp
  PropertyCreationDialog.cpp
  QGlBufferManager.cpp
  QtGlSceneZoomAndPanAnimator.cpp
  QuaZIPFacade.cpp
  RenamePropertyDialog.cpp
  SimplePluginProgressWidget.cpp
  SimpleStringsListSelectionWidget.cpp
  StringsListSelectionWidget.cpp
  StringsListSelectionDialog.cpp
  TlpQtTools.cpp
  TulipProject.cpp
  TulipSettings.cpp
  ParameterListModel.cpp
  TulipItemDelegate.cpp
  TulipMetaTypes.cpp
  TulipItemEditorCreators.cpp
  Animation.cpp
  DoublePropertyAnimation.cpp
  LayoutPropertyAnimation.cpp
  PropertyAnimation.cpp
  TulipParallelAnimationGroup.cpp
  ColorButton.cpp
  TulipModel.cpp
  ColorScaleButton.cpp
  View.cpp
  GlMainWidgetGraphicsItem.cpp
  ViewWidget.cpp
  InteractorComposite.cpp
  GLInteractor.cpp
  TulipWorkspace.cpp
  WorkspacePanel.cpp
  Interactor.cpp
  ProcessingAnimationItem.cpp
  Workspace.cpp
  PlaceHolderWidget.cpp
  TulipFileDescriptorWidget.cpp
  GraphHierarchiesModel.cpp
  CoordEditor.cpp
  GlOverviewGraphicsItem.cpp
  SceneConfigWidget.cpp
  QuickAccessBar.cpp
  TulipFont.cpp
  TulipFontDialog.cpp
  ScrollPopupButton.cpp
  WorkspaceExposeWidget.cpp
  GraphTableItemDelegate.cpp
  StringEditor.cpp
  VectorEditor.cpp
  GlyphRenderer.cpp
  TulipFontWidget.cpp
  ClearableLineEdit.cpp
  CaptionItem.cpp
  CaptionGraphicsItem.cpp
  CaptionGraphicsSubItems.cpp
  GraphModel.cpp
  GraphElementModel.cpp
  SnapshotDialog.cpp
  TulipMimes.cpp
  SceneLayersModel.cpp
  SceneLayersConfigWidget.cpp
  TreeViewComboBox.cpp
  GlSimpleEntityItemModel.cpp
  PluginModel.cpp
  GraphNeedsSavingObserver.cpp
)

IF(BUILD_PYTHON_COMPONENTS)
  SET(SRCS ${SRCS} PythonVersionChecker.cpp)
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DBUILD_PYTHON_COMPONENTS")
  SET_SOURCE_FILES_PROPERTIES(PythonVersionChecker.cpp
                              PROPERTIES COMPILE_DEFINITIONS TLP_PYTHON="${PYTHON_VERSION}")
ENDIF(BUILD_PYTHON_COMPONENTS)

QTX_WRAP_UI(UI_HEADERS
  ../designer/ColorScaleConfigDialog.ui
  ../designer/CopyPropertyDialog.ui
  ../designer/CSVGraphMappingConfigurationWidget.ui
  ../designer/CSVImportConfigurationWidget.ui
  ../designer/CSVImportWizard.ui
  ../designer/CSVParserConfigurationWidget.ui
  ../designer/DoubleStringsListSelectionWidget.ui
  ../designer/PropertyCreationDialog.ui
  ../designer/RenamePropertyDialog.ui
  ../designer/SimplePluginProgressWidget.ui
  ../designer/SimpleStringsListSelectionWidget.ui
  ../designer/StringsListSelectionDialog.ui
  ../designer/WorkspacePanel.ui
  ../designer/Workspace.ui
  ../designer/CoordEditor.ui
  ../designer/SceneConfigWidget.ui
  ../designer/QuickAccessBar.ui
  ../designer/TulipFontDialog.ui
  ../designer/VectorEditor.ui
  ../designer/TulipFontWidget.ui
  ../designer/GridOptionsWidget.ui
  ../designer/ElementInformationsWidget.ui
  ../designer/SnapshotDialog.ui
  ../designer/SceneLayersConfigWidget.ui
)

QTX_WRAP_CPP(MOC_SRCS
  ../include/tulip/ColorScaleConfigDialog.h
  ../include/tulip/CopyPropertyDialog.h
  ../include/tulip/CSVGraphMappingConfigurationWidget.h
  ../include/tulip/CSVImportConfigurationWidget.h
  ../include/tulip/CSVImportWizard.h
  ../include/tulip/CSVParserConfigurationWidget.h
  ../include/tulip/DocumentationNavigator.h
  ../include/tulip/DoubleStringsListSelectionWidget.h
  ../include/tulip/DownloadManager.h
  ../include/tulip/GlMainView.h
  ../include/tulip/GlMainWidget.h
  ../include/tulip/ItemsListWidget.h
  ../include/tulip/NodeLinkDiagramComponent.h
  ../include/tulip/Perspective.h
  ../include/tulip/PropertyCreationDialog.h
  ../include/tulip/QtGlSceneZoomAndPanAnimator.h
  ../include/tulip/RenamePropertyDialog.h
  ../include/tulip/SimplePluginProgressWidget.h
  ../include/tulip/SimpleStringsListSelectionWidget.h
  ../include/tulip/StringsListSelectionDialog.h
  ../include/tulip/TulipProject.h
  ../include/tulip/Animation.h
  ../include/tulip/ColorButton.h
  ../include/tulip/TulipModel.h
  ../include/tulip/ColorScaleButton.h
  ../include/tulip/TulipSettings.h
  ../include/tulip/View.h
  ../include/tulip/ViewWidget.h
  ../include/tulip/GlMainWidgetGraphicsItem.h
  ../include/tulip/Interactor.h
  ../include/tulip/InteractorComposite.h
  ../include/tulip/GLInteractor.h
  ../include/tulip/WorkspacePanel.h
  ../include/tulip/TulipWorkspace.h
  ../include/tulip/ProcessingAnimationItem.h
  ../include/tulip/Workspace.h
  ../include/tulip/TulipFileDescriptorWidget.h
  ../include/tulip/PlaceHolderWidget.h
  ../include/tulip/GraphHierarchiesModel.h
  ../include/tulip/CoordEditor.h
  ../include/tulip/GlOverviewGraphicsItem.h
  ../include/tulip/SceneConfigWidget.h
  ../include/tulip/QuickAccessBar.h
  ../include/tulip/TulipFont.h
  ../include/tulip/TulipFontDialog.h
  ../include/tulip/ScrollPopupButton.h
  ../include/tulip/WorkspaceExposeWidget.h  
  ../include/tulip/GraphTableItemDelegate.h
  ../include/tulip/VectorEditor.h
  ../include/tulip/TulipFontWidget.h
  ../include/tulip/CaptionItem.h
  ../include/tulip/CaptionGraphicsItem.h
  ../include/tulip/CaptionGraphicsSubItems.h
  ../include/tulip/GraphNeedsSavingObserver.h
  ../include/tulip/DragHandle.h
  ../include/tulip/SnapshotDialog.h
  ../include/tulip/SceneLayersModel.h
  ../include/tulip/SceneLayersConfigWidget.h
  ../include/tulip/TulipMimes.h
  ../include/tulip/TreeViewComboBox.h
  ../include/tulip/TulipItemDelegate.h
  ../include/tulip/GlSimpleEntityItemModel.h
)

QTX_ADD_RESOURCES(RCC_SRCS ../resources/TulipGUIResource.qrc)

ADD_DEFINITIONS(-DQT_DLL)
ADD_DEFINITIONS(-DQT_THREAD_SUPPORT)

INCLUDE_DIRECTORIES(../include ${TulipCoreInclude} ${TulipCoreBuildInclude} ${TulipOGLInclude} ${TulipGUIBuildInclude} ${CMAKE_CURRENT_BINARY_DIR} ${ZLIB_INCLUDE_DIR} ${GLEW_INCLUDE_DIR} ${QuazipInclude} ${QxtInclude} ${QtAwesomeInclude})
ADD_LIBRARY(${LibTulipGUIName} SHARED ${SRCS} ${MOC_SRCS} ${RCC_SRCS} ${UI_HEADERS})
TARGET_LINK_LIBRARIES(${LibTulipGUIName} ${QT_LIBRARIES} ${LibTulipCoreName} ${LibTulipOglName} ${QuazipLibrary} ${QxtLibrary} ${QtAwesomeLibrary})

INSTALL(TARGETS ${LibTulipGUIName}
  RUNTIME DESTINATION ${TulipBinInstallDir} COMPONENT tulip_gui
  LIBRARY DESTINATION ${TulipLibInstallDir} COMPONENT tulip_gui
  ARCHIVE DESTINATION ${TulipLibInstallDir} COMPONENT tulip_gui)

INSTALL(FILES ../resources/icons/tulip.ico DESTINATION ${TulipBitmapInstallDir})
INSTALL(FILES ../resources/icons/tulip-file-icon.ico DESTINATION ${TulipBitmapInstallDir})

=== debian/changelog ===
tulip (4.7.0dfsg-1ubuntu1) wily; urgency=medium

  * Rename library packages for g++5 ABI transition.

 -- Iain Lane <iain@orangesquash.org.uk>  Tue, 04 Aug 2015 11:43:50 +0100

tulip (4.7.0dfsg-1) unstable; urgency=medium

  * New upstream release.
    * New thirdparty lib QtAwesome, adding to debian/copyright.
  * Filtered fontawesome-webfont.ttf from dfsg package, removed it from
    the list of files to be installed.
  * Replace installed fontawesome-webfont.ttf with a symlink, depend on
    fonts-font-awesome accordingly.
  * Switch to Qt5 (Closes: #784533).
  * Fixed wrong description of libtulip-python package.
  * Some rewording of debian/README.maint.
  * Reworked debian/copyright using License clauses.

 -- Yann Dirson <dirson@debian.org>  Wed, 20 May 2015 20:21:23 +0200

=== debian/control ===
Source: tulip
Section: graphics
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Yann Dirson <dirson@debian.org>
Build-Depends: debhelper (>= 9), cmake, qtbase5-dev, libqt5opengl5-dev, libqt5webkit5-dev, libqt5xmlpatterns5-dev, freeglut3-dev, docbook-to-man, libgl1-mesa-dev | libgl-dev, dh-buildinfo, libfreetype6-dev, libxml2-dev, libgle3-dev, libxml2-utils, graphviz, libjpeg-dev, libpng-dev, libftgl-dev, libglew-dev, binutils-dev [linux-i386 kfreebsd-i386 any-amd64], python-sip-dev, libutfcpp-dev
Homepage: http://tulip-software.org/
Standards-Version: 3.9.6
Vcs-git: git://anonscm.debian.org/collab-maint/tulip.git
Vcs-browser: http://anonscm.debian.org/gitweb/?p=collab-maint/tulip.git

Package: tulip
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, fonts-dejavu-core, fonts-font-awesome
Description: System dedicated to the visualization of huge data sets as graphs
 Tulip is an information visualization framework dedicated to the
 analysis and visualization of relational data.  It aims to provide
 the developer with a complete library, supporting the design of
 interactive information visualization applications for relational
 data that can be tailored to the problems he or she is addressing.
 .
 It includes the following features:
 .
  * 3D visualizations
  * 3D modifications
  * Plug-in support for easy evolution
  * Building of clusters and navigation into them
  * Automatic drawing of graphs
  * Automatic clustering of graphs
  * Automatic selection of elements
  * Automatic metric coloration of graphs

Package: tulip-dbg
Section: debug
Priority: extra
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, tulip (= ${binary:Version})
Description: Tulip graph library - debug symbols
 Debug symbols for tulip, a system dedicated to the visualization of
 huge graphs, and its various libraries.

Package: libtulip-dev
Section: libdevel
Architecture: any
Depends: tulip (= ${binary:Version}), libc6-dev, ${misc:Depends}
Conflicts: libtulip-dev
Replaces: tulip (<= 2), libtulip-ogl-dev, libtulip-qt4-dev
Suggests: cmake
Enhances: qtcreator
Description: Tulip graph library - core development files
 Headers and static libraries for tulip, a system dedicated to the
 visualization of huge graphs.  Also include QtCreator templates.

Package: libtulip-core-4.7
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Tulip graph library - core runtime
 Runtime for tulip, a system dedicated to the visualization of huge graphs.
 .
 This is the core of the system, excluding the OpenGL rendering capabilities.

Package: libtulip-ogl-4.7
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Tulip graph library - OpenGL runtime
 Runtime for tulip, a system dedicated to the visualization of huge graphs.
 .
 This library contains the OpenGL rendering capabilities of the engine.

Package: libtulip-gui-4.7
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Tulip graph library - Qt/OpenGL GUI runtime
 Runtime for tulip, a system dedicated to the visualization of huge graphs.
 .
 This library contains the Qt/OpenGL GUI support.

Package: libtulip-python-4.7
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Provides: libtulip-python
Conflicts: libtulip-python
Description: Tulip graph library - Python support
 Runtime for tulip, a system dedicated to the visualization of huge graphs.
 .
 This library contains the Python scripting support.

Package: libtulip-ogdf-4.7
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Tulip graph library - OGDF runtime
 Runtime for tulip, a system dedicated to the visualization of huge graphs.
 .
 This library contains the Open Graph Drawing Framework support.

Package: libogdf-tulip-4.7-0v5
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libogdf-tulip-4.7-0
Replaces: libogdf-tulip-4.7-0
Description: Open Graph Drawing Framework shared library, built for Tulip
 This is the Open Graph Drawing Framework library, built as a shared
 lib as required by Tulip.

Package: libgzstream-tulip-4.7-0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: gzstream shared library, built for Tulip
 C++ iostream classes wrapping the zlib compression library, built as
 a shared lib as required by Tulip.

Package: libquazip-tulip-4.7-1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: quazip shared library, built for Tulip
 Runtime for the quazip C++ wrapper for ZIP/UNZIP, built as a
 shared lib as required by Tulip.

Package: libqxt-tulip-4.7-0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: qxt shared library, built for Tulip
 Runtime for a subset of Qxt, extensions to Qt core classes, built as
 a shared lib as required by Tulip.

Package: libyajl-tulip-4.7-2
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: yajl shared library, built for Tulip
 Runtime for yajl, Yet Another JSON Library, built as a shared lib as
 required by Tulip.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#export DH_VERBOSE=1

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_SKIP_RPATH:BOOL=YES -DUBUNTU_PPA_BUILD=ON -DBUILD_DOC=OFF -DUSE_QT5_IF_INSTALLED=YES

override_dh_auto_build-arch:
	dh_auto_build --parallel
	docbook-to-man debian/tulip.sgml > debian/tulip.1

override_dh_auto_install-arch:
	dh_auto_install
	install -D -m644 debian/tulip.1 debian/tmp/usr/share/man/man1/tulip.1
	install -D -m644 debian/tulip.desktop debian/tmp/usr/share/applications/tulip.desktop
	install -D -m644 debian/TulipIcon.png debian/tmp/usr/share/pixmaps/TulipIcon.png
 #	cd debian/tmp/usr/share/doc && mv tulip-python libtulip-python-4.4
 # apply README instructions: install qtcreator templates in the correct place
	mkdir -p debian/tmp/usr/share/qtcreator/templates
	mv debian/tmp/usr/share/tulip/wizards/* debian/tmp/usr/share/qtcreator/templates/
	rmdir debian/tmp/usr/share/tulip/wizards
	rm debian/tmp/usr/share/qtcreator/templates/README.txt

override_dh_install:
	dh_install --fail-missing

override_dh_installdocs:
	dh_installdocs
	dh_buildinfo

override_dh_strip:
	dh_strip --dbg-package tulip-dbg

override_dh_auto_clean:
	dh_auto_clean
	rm -f debian/tulip.1
	rm -rf docs/doxygen/xml
